FROM ubuntu:18.04 as souffle
RUN apt-get -y update && apt-get -y install automake bison build-essential \
    doxygen flex git libffi-dev libtool make mcpp pkg-config \
    sqlite3 libsqlite3-dev zlib1g-dev

RUN git clone -b 1.6.1 https://github.com/souffle-lang/souffle
RUN cd souffle && sh ./bootstrap
RUN cd souffle && ./configure --prefix=/usr --enable-64bit-domain --disable-ncurses
RUN cd souffle && make -j4 install
RUN cd souffle && cp include/souffle/RamTypes.h /usr/include/souffle/

FROM ubuntu:18.04

ENV LD_LIBRARY_PATH /usr/local/lib:$LD_LIBRARY_PATH
ARG BOOST_VERSION=1.67.0
ARG CXX_COMPILER=g++-7

# Use bash for more convenient variable substitution syntax
SHELL ["/bin/bash", "-c"]

# Install common packages
RUN apt-get -y update && apt-get -y install autoconf automake clang cmake \
    curl doxygen git libprotobuf-dev libtool libstdc++-7-dev \
    make mcpp pkg-config protobuf-compiler python3 python3-pip wget zlib1g-dev

COPY --from=souffle /usr/bin/souffle-compile /usr/bin/souffle-compile
COPY --from=souffle /usr/bin/souffle-config /usr/bin/souffle-config
COPY --from=souffle /usr/bin/souffle /usr/bin/souffle
COPY --from=souffle /usr/bin/souffle-profile /usr/bin/souffle-profile
COPY --from=souffle /usr/include/souffle/ /usr/include/souffle

# Install Boost
RUN curl -L https://dl.bintray.com/boostorg/release/${BOOST_VERSION}/source/boost_${BOOST_VERSION//./_}.tar.gz > boost.tar.gz && \
    tar vxfz boost.tar.gz > /dev/null && \
    cd boost_${BOOST_VERSION//./_} && \
    ./bootstrap.sh --prefix=/usr/local --with-libraries=filesystem,program_options,system > /dev/null && \
    ./b2 install --prefix=/usr/local > /dev/null && \
    rm ../boost.tar.gz && \
    cd .. && \
    rm -rf boost_${BOOST_VERSION//./_}

# Install capstone
RUN cd /usr/local/src \
    && wget https://github.com/aquynh/capstone/archive/4.0.1.tar.gz \
    && tar xf 4.0.1.tar.gz \
    && cd capstone-4.0.1 \
    && CAPSTONE_ARCHS=x86 ./make.sh \
    && CAPSTONE_ARCHS=x86 ./make.sh install


# Install LIEF
RUN cd /usr/local/src \
    && git clone -b 0.9.0 https://github.com/lief-project/LIEF.git \
    && cd LIEF \
    && mkdir build \
    && cd build \
    && cmake -DLIEF_PYTHON_API=off -DCMAKE_BUILD_TYPE=Release .. \
    && cmake --build . --target LIB_LIEF_STATIC --config Release \
    && make install

COPY . /ddisasm

# Build GTIRB
RUN rm -rf /ddisasm/gtirb/build /ddisasm/gtirb/CMakeCache.txt /ddisasm/gtirb/CMakeFiles /ddisasm/gtirb/CMakeScripts
RUN cd /ddisasm/gtirb/ && cmake ./ -Bbuild -DCMAKE_CXX_COMPILER=${CXX_COMPILER} && cd build &&  make install

# Build gtirb-pprinter
RUN rm -rf /ddisasm/gtirb-pprinter/build /ddisasm/gtirb-pprinter/CMakeCache.txt /ddisasm/gtirb-pprinter/CMakeFiles /ddisasm/gtirb-pprinter/CMakeScripts
RUN cd /ddisasm/gtirb-pprinter/ && cmake ./ -Bbuild -DCMAKE_CXX_COMPILER=${CXX_COMPILER} && cd build &&  make

# Build ehp
RUN rm -rf /ddisasm/libehp/build /ddisasm/libehp/CMakeCache.txt /ddisasm/libehp/CMakeFiles /ddisasm/libehp/CMakeScripts
RUN cd /ddisasm/libehp/ && cmake ./ -Bbuild -DCMAKE_CXX_COMPILER=${CXX_COMPILER} && cd build &&  make

# Build ddisasm
ENV TERM xterm
RUN rm -rf /ddisasm/build /ddisasm/CMakeCache.txt /ddisasm/CMakeFiles /ddisasm/CMakeScripts
WORKDIR /ddisasm
RUN cmake ./  -Bbuild -DCMAKE_CXX_COMPILER=${CXX_COMPILER} -DCORES=8 -DLIEF_ROOT=/usr/ && cd build && make
ENV PATH=/ddisasm/build/bin:$PATH
